/**
 * (C) 2011-2012 Alibaba Group Holding Limited.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 */
/**
 * Copyright 2007 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.taobao.common.tedis.support.paoding;


/**
 * {@link Beef}ҪҶ⡱ġţ⡱ǶıַĸЧװԴжȡָλõַ
 * <p>
 * {@link Beef}{@link String}Ĳ֮ͬڣ<br>
 * {@link Beef}char飬{@link String}ĲǶԹп¡¡ܡ<br>
 * ͬʱ{@link Beef} {@link #charAt(int)}жַԤʹʱϹ:1)toLowerCase
 * 2)ȫתǵ
 * <p>
 *
 * @author Zhiliang Wang [qieqie.wang@gmail.com]
 *
 * @since 1.0
 *
 */
public class Beef implements CharSequence {

    // -------------------------------------------------

    /**
     * ıַ
     */
    private final char[] value;

    /**
     * ַʼλãcharAt(i)value[offset+i]ַ
     */
    private int offset;

    /**
     * offsetλÿʼַ
     */
    private int count;

    /** Cache the hash code for the beef */
    private int hash; // Default to 0

    // -------------------------------------------------

    /**
     * 캯
     *
     * @param body
     *            ֱӵеıַ
     * @param offset
     *            ַʼλãget(i)body[offset+i]ַ
     * @param count
     *            offsetλÿʼַ
     */
    public Beef(char[] value, int offset, int count) {
        this.value = value;
        set(offset, count);
    }

    // -------------------------------------------------

    public void set(int offset, int count) {
        if (offset < 0) {
            throw new StringIndexOutOfBoundsException(offset);
        }
        if (count < 0) {
            throw new StringIndexOutOfBoundsException(count);
        }
        if (offset > value.length - count) {
            throw new StringIndexOutOfBoundsException(offset + count);
        }
        this.offset = offset;
        this.count = count;
    }

    public char[] getValue() {
        return value;
    }

    public int getCount() {
        return count;
    }

    public int getOffset() {
        return offset;
    }

    // -------------------------------------------------

    /**
     * ȡָλõַ֮ǰԤ1)toLowerCase2)ȫתǵ
     */
    public char charAt(int index) {
        if (index >= 0 && index < count) {
            char src = value[offset + index];
            if (src > 65280 && src < 65375) {
                src = (char) (src - 65248);
                value[offset + index] = src;
            }
            if (src >= 'A' && src <= 'Z') {
                src += 32;
                value[offset + index] = src;
            } else if (src == 12288) {
                src = 32;
                value[offset + index] = 32;
            }
            return src;
        }
        return (char) -1;
    }

    public int length() {
        return count;
    }

    public CharSequence subSequence(int start, int end) {
        return new Beef(value, offset + start, end - start);
    }

    // -------------------------------------------------

    @Override
    public String toString() {
        return new String(value, offset, count);
    }

    @Override
    public int hashCode() {
        int h = hash;
        if (h == 0) {
            int off = offset;
            char val[] = value;
            int len = count;

            for (int i = 0; i < len; i++) {
                h = 31 * h + val[off++];
            }
            hash = h;
        }
        return h;
    }

}
